#ifndef LOCAL
  #pragma GCC optimize("Ofast,unroll-loops")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#ifndef LOCAL
  #pragma GCC target("avx,avx2,fma")
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define all(x) begin(x), end(x)
#define isz(x) (int)size(x)

void solve() {
  int n, m, g;
  cin >> n >> m >> g;
  vector<bool> use(n + 1, false);
  for (int i = 0; i < m; ++i) {
    int u, v;
    cin >> u >> v;
    if (v == u + 1) use[u] = 1;
  }
  for (int i = 1; i < n; ++i) {
    if (!use[i]) {
      cout << "0 1\n";
      return;
    }
  }
  cout << m - (n - 1) << " 1\n";
}

signed main() {
  cin.tie(0)->sync_with_stdio(0);
  int t = 1;
  // cin >> t;
  for (int i = 0; i < t; ++i) {
    solve();
  }
}